Bug 153580

Summary: Tower of Babel-like confusion around the meaning of the +q and +a user modes
Product: konversation Reporter: Oliver Lewisohn <ollie.jl>
Component: protocolAssignee: Konversation Developers <konversation-devel>
Status: CONFIRMED ---    
Severity: normal CC: cathy, edwardfredriks, error.syntax0, hein, johu, m.niggli, mailomaysara, OldShatterhand, rdieter, shentino
Priority: NOR    
Version: 1.5-rc1   
Target Milestone: ---   
Platform: openSUSE RPMs   
OS: Linux   
Latest Commit: Version Fixed In:
Attachments: Patch that fixes the issue

Description Oliver Lewisohn 2007-12-06 19:58:25 UTC
Version:            (using KDE KDE 3.5.7)
Installed from:    SuSE RPMs
OS:                Linux

Whichever set of icons I use for the Nicklist in Konversation, it shows users with Admin status (mode +a) with the Owner icon (mode +q), thus making them indistinguishable from those users who are actually meant to be Owners. This bug is in effect most, but not all, of the time.
Comment 1 argonel 2008-04-18 16:40:08 UTC
What network is this happening on?
Comment 2 Marc 2008-07-19 22:21:57 UTC
I've the same problem on my IRC Networks.

I send that I've when I connect to my IRC Network :
[09:02] [Bienvenue] Your host is Kolosse.MoonScoop-Fan.com, running version Unreal3.2.7
[09:02] [Bienvenue] This server was created samedi 31 mai (UTC+0200) at 2008, 00:10:37
[09:02] [Bienvenue] Serveur Kolosse.MoonScoop-Fan.com (Version Unreal3.2.7), Modes utilisateur : iowghraAsORTVSxNCWqBzvdHtGp, Modes canal : lvhopsmntikrRcaqOALQbSeIKVfMCuzNTGj
[09:02] [Gérer] Neurones67 CMDS=KNOCK,MAP,DCCALLOW,USERIP NAMESX SAFELIST HCN MAXCHANNELS=25 CHANLIMIT=#:25 MAXLIST=b:60,e:60,I:60 NICKLEN=30 CHANNELLEN=32 TOPICLEN=307 KICKLEN=307 AWAYLEN=307 MAXTARGETS=20
[09:02] [Gérer] Neurones67 WALLCHOPS WATCH=128 SILENCE=15 MODES=12 CHANTYPES=# PREFIX=(qaohv)~&@%+ CHANMODES=beI,kfL,lj,psmntirRcOAQKVCuzNSMTG NETWORK=MoonScoop-Fan.com CASEMAPPING=ascii EXTBAN=~,cqnr ELIST=MNUCT STATUSMSG=~&@%+ EXCEPTS

If you need further informations, tell me :)
and sorry for my bad english, I'm french :)
Comment 3 Michael Niggli 2009-01-08 19:11:35 UTC
I can reproduce this with Konversation 1.1 and KDE 3.5.10 on Gentoo in euIRC (irc.euirc.net)
Comment 4 Michael Niggli 2009-01-08 20:00:37 UTC
Just now I found that it's not just the wrong state for admin, but that owner/admin status appear to be interchanged..
Comment 5 Eike Hein 2009-05-13 01:21:04 UTC
Likely related to bug #139591 and #148437.
Comment 6 Rolo Lamperouge 2009-06-03 14:21:40 UTC
I have firsthand experience with this bug, the icon changes when mode +a is granted on a user, not (for example) when you join the channel and there are admins already there. This would be a very nice fix for the final release of 1.2
Comment 7 Eike Hein 2009-12-27 17:20:34 UTC
*** Bug 220285 has been marked as a duplicate of this bug. ***
Comment 8 Frederik Schwarzer 2009-12-27 17:27:38 UTC
*** Bug 220285 has been marked as a duplicate of this bug. ***
Comment 9 shentino 2011-11-17 04:52:12 UTC
I would like to confirm this bug as still present in 1.3.1 on Gentoo Linux.
Comment 10 Cathy J. Fitzpatrick 2013-02-19 00:07:59 UTC
*** Bug 315424 has been marked as a duplicate of this bug. ***
Comment 11 Cathy J. Fitzpatrick 2013-02-19 00:08:23 UTC
Created attachment 77417 [details]
Patch that fixes the issue

Please find attached a patch that fixes this bug.
Comment 12 argonel 2013-02-19 03:54:12 UTC
Thanks for the patch. On what network and IRCd are you seeing this issue?


On Mon, Feb 18, 2013 at 7:08 PM, Cathy J. Fitzpatrick <cathy@cathyjf.com>wrote:

> https://bugs.kde.org/show_bug.cgi?id=153580
>
> --- Comment #11 from Cathy J. Fitzpatrick <cathy@cathyjf.com> ---
> Created attachment 77417 [details]
>   --> https://bugs.kde.org/attachment.cgi?id=77417&action=edit
> Patch that fixes the issue
>
> Please find attached a patch that fixes this bug.
>
> --
> You are receiving this mail because:
> You are the assignee for the bug.
> _______________________________________________
> Konversation-devel mailing list
> Konversation-devel@kde.org
> https://mail.kde.org/mailman/listinfo/konversation-devel
>
Comment 13 Cathy J. Fitzpatrick 2013-02-19 04:07:04 UTC
[16:44:18] [Welcome] Welcome to the synIRC IRC Network Cathy!~Cathy@...
[16:44:18] [Welcome] Your host is moonlight.se.eu.synirc.net, running version Unreal3.2.9
[16:44:18] [Welcome] This server was created Tue Jun 19 2012 at 21:04:53 CEST
[16:44:18] [Welcome] Server moonlight.se.eu.synirc.net (Version Unreal3.2.9), User modes: iowghraAsORTVSxNCWqBzvdHtGp, Channel modes: lvhopsmntikrRcaqOALQbSeIKVfMCuzNTGjZ
[16:44:18] [Support] Cathy CMDS=KNOCK,MAP,DCCALLOW,USERIP UHNAMES NAMESX SAFELIST HCN MAXCHANNELS=40 CHANLIMIT=#:40 MAXLIST=b:60,e:60,I:60 NICKLEN=30 CHANNELLEN=32 TOPICLEN=307 KICKLEN=307 AWAYLEN=307 are supported by this server
[16:44:18] [Support] Cathy MAXTARGETS=20 WALLCHOPS WATCH=128 WATCHOPTS=A SILENCE=15 MODES=12 CHANTYPES=# PREFIX=(qaohv)~&@%+ CHANMODES=beI,kfL,lj,psmntirRcOAQKVCuzNSMTGZ NETWORK=synIRC CASEMAPPING=ascii EXTBAN=~,qjncrR ELIST=MNUCT are supported by this server
[16:44:18] [Support] Cathy STATUSMSG=~&@%+ EXCEPTS INVEX are supported by this server
[16:44:18] [Notice] -moonlight.se.eu.synirc.net- *** You are connected to moonlight.se.eu.synirc.net with TLSv1-AES256-SHA-256bits


That said, I don't think my proposed patch will have side effects on other networks. The code in the region I changed already assumes that mode +a is admin (not owner). The call to setOwner() appears to just be a typo.
Comment 14 Eike Hein 2013-04-15 02:56:51 UTC
*** Bug 308016 has been marked as a duplicate of this bug. ***
Comment 15 Eike Hein 2013-04-15 03:09:21 UTC
*** Bug 148437 has been marked as a duplicate of this bug. ***
Comment 16 Eike Hein 2013-04-15 03:09:56 UTC
Note that bug 148437 introduces an additional meaning of "super OPs" for +q.
Comment 17 shentino 2013-05-25 22:27:36 UTC
I've tested Fitzpatrick's patch and it works.

I think we should go ahead and apply it to the mainline.  It fixes an obvious bug and it doesn't appear to conflict with the mode rework.

Furthermore, the mode rework may yet take a long while.
Comment 18 Eike Hein 2013-05-26 19:21:52 UTC
I'd like to hear Eli's opinion on that since he's the domain expert.
Comment 19 shentino 2013-05-26 23:36:32 UTC
I had a nice chat with argonel on irc's #konversation and the consensus is that this is indeed a typo being fixed.

Said that there was a good chance of it popping into 1.5.
Comment 20 Eike Hein 2013-06-17 03:58:19 UTC
Git commit 5b79cf8cad9781f37f52f77a71353ea4caf64698 by Eike Hein, on behalf of Cathy J. Fitzpatrick.
Committed on 19/02/2013 at 00:46.
Pushed by hein into branch '1.5'.

Fix for setting mode +a or -a

Previously, setting or removing mode +a on a nick in a channel called
ChannelNick::setOwner(), so setting +a on a nick made the nick appear
as an owner of the channel, rather than as an admin. This commit
fixes the problem by correctly calling ChannelNick::setAdmin() instead.

M  +1    -1    src/irc/channel.cpp

http://commits.kde.org/konversation/5b79cf8cad9781f37f52f77a71353ea4caf64698